//+------------------------------------------------------------------+
//|                                                  TestMoments.mq4 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property strict
//---
#define MAX_SIZE 5750
//---
#define IM 139968
#define IA 3877
#define IC 29573
//---
double nums[MAX_SIZE];
//+------------------------------------------------------------------+
//| OnStart function                                                 |
//+------------------------------------------------------------------+
int OnStart()
  {
   int  i;
   uint tick_count,res;
//--- test
   for(i=0;i<MAX_SIZE;i++)
      nums[i]=TestRandom(1000000.0);
   tick_count=GetTickCount();
   for(i=0;i<MAX_SIZE;i++)
      TestMoments();
   res=GetTickCount()-tick_count;
   Print("Testing statistical moments ",res," ms.");
//--- returns test execution time, in milliseconds
   return((int)res);
  }
//+------------------------------------------------------------------+
//| Test function                                                    |
//+------------------------------------------------------------------+
void TestMoments()
  {
   int i,mid=0;
   double sum=0.0;
   double mean=0.0;
   double average_deviation=0.0;
   double standard_deviation=0.0;
   double variance=0.0;
   double skew=0.0;
   double kurtosis=0.0;
   double median=0.0;
   double deviation=0.0;
   int array_size=4096;
//---
   mean = sum/MAX_SIZE;
   for(i=0; i<MAX_SIZE; i++)
     {
      deviation=nums[i]-mean;
      average_deviation+=MathAbs(deviation);
      variance+=MathPow(deviation,2);
      skew+=MathPow(deviation,3);
      kurtosis+=MathPow(deviation,4);
     }
   average_deviation/=MAX_SIZE;
   variance/=(MAX_SIZE-1);
   standard_deviation=MathSqrt(variance);
   if(variance)
     {
      skew/=(MAX_SIZE*variance*standard_deviation);
      kurtosis=(kurtosis/(MAX_SIZE*variance*variance))-3.0;
     }
   mid=(MAX_SIZE/2);
   median=(MAX_SIZE%2) ? nums[mid]:(nums[mid]+nums[mid-1])/2;
  }
//+------------------------------------------------------------------+
//| Test function                                                    |
//+------------------------------------------------------------------+
double TestRandom(double max)
  {
   static long last=42;
//---
   last=(last*IA+IC)%IM;
   return(max*last/IM);
  }
//+------------------------------------------------------------------+
