//+------------------------------------------------------------------+
//|                                                TestQuickSort.mq4 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property strict
//---
#define MAX_SIZE 16000000
//---
int array[];
//+------------------------------------------------------------------+
//| OnStart function                                                 |
//+------------------------------------------------------------------+
int OnStart()
  {
   uint tick_count,res;
   int  size;
   int  file_handle=FileOpen("big_file.bin",FILE_BIN|FILE_READ);
//--- check
   if(file_handle==INVALID_HANDLE) return(0);
//--- reading array
   Print("Testing performance of 'Quick sorting'");
   tick_count=GetTickCount();
   size=FileReadArray(file_handle,array,0,MAX_SIZE);
   Print("Reading array (",size," bytes )",GetTickCount()-tick_count,"ms.");
   FileClose(file_handle);
//--- sorting
   tick_count=GetTickCount();
   QuickSort(array,0,MAX_SIZE-1);
   res=GetTickCount()-tick_count;
   Print("Sorting array",res," ms.");
//--- returns test execution time, in milliseconds
   return((int)res);
  }
//+------------------------------------------------------------------+
//| Quick sort function                                              |
//+------------------------------------------------------------------+
void QuickSort(int &arr[],int left,int right)
  {
   int i=left;
   int j=right;
   int center=arr[(i+j)/2];
   int x;
//---
   while(i<=j)
     {
      while(arr[i]<center && i<right) i++;
      while(arr[j]>center && j>left) j--;
      if(i<=j)
        {
         x=arr[i];
         arr[i]=arr[j];
         arr[j]=x;
         i++;
         j--;
        }
     }
   if(left<j) QuickSort(arr,left,j);
   if(right>i) QuickSort(arr,i,right);
  }
//+------------------------------------------------------------------+
